<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getPageMetadata } from '~/common/meta';
import { NextStepAlt } from '~/components/common/index.vue';
import { ResourceCards } from '~/components/home/index.vue';
import {
  GetStartedCopyInfo,
  GetStartedHero,
  GetStartedSteps,
} from '~/components/get-started/index.vue';
import GetStartedNextSteps from '~/components/get-started/next-steps.vue';

export default Vue.extend({
  name: 'GetStarted',
  components: {
    GetStartedNextSteps,
    GetStartedSteps,
    GetStartedCopyInfo,
    GetStartedHero,
    ResourceCards,
    NextStepAlt,
  },
  async asyncData({ params, $getStartedService }: any) {
    try {
      const isIndexSlug = !params.slug;
      const doc = await $getStartedService.getContent(
        `get-started/${params.slug}`,
        isIndexSlug,
      );

      return { doc };
    } catch (e) {
      throw new Error(e);
    }
  },
  head(): MetaInfo {
    return getPageMetadata(
      (this as any).doc,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
});
</script>

<template>
  <div>
    <SlpContainer>
      <GetStartedHero v-if="doc.hero" :data="doc.hero" />
    </SlpContainer>
    <SlpContainer v-if="doc.side_menu">
      <SlpSideNavigation :data="doc.side_menu">
        <SlpRow>
          <SlpColumn :cols="10">
            <GetStartedCopyInfo v-if="doc.copy_info" :data="doc.copy_info" />
            <GetStartedSteps v-if="doc.steps" :data="doc.steps" />
          </SlpColumn>
        </SlpRow>
      </SlpSideNavigation>
    </SlpContainer>
    <div v-if="doc.next_steps" class="slp-bg-surface-800 slp-py-96">
      <SlpContainer>
        <GetStartedNextSteps :data="doc.next_steps" />
      </SlpContainer>
    </div>
    <SlpContainer>
      <component
        :is="component.name"
        v-for="component in doc.components"
        :key="component.name"
        :data="component.data"
      />
    </SlpContainer>
    <section v-if="doc.resource_card_block">
      <ResourceCards :data="doc.resource_card_block" />
    </section>
    <NextStepAlt />
  </div>
</template>

<style scoped lang="scss">
:deep(#collapsible-sidebar-wrapper) {
  justify-content: space-between;
}
:deep(#collapsible-sidebar-content) {
  width: 100%;
}
</style>
